// copy-of-xsd-bug.cpp : Defines the entry point for the console application.
//

#include <libxml/xmlIO.h>
#include <libxslt/xslt.h>
#include <libxslt/xsltInternals.h>
#include <libxslt/transform.h>
#include <libxslt/xsltutils.h>
#include <libexslt/exslt.h>
#include <libxml/xmlschemas.h>
#include <libxml/xmlschemastypes.h>

int main(int argc, char * argv[])
{
	xmlDocPtr transformedDoc = NULL;
	
/* libXSLT setup */
	exsltRegisterAll();
	xmlSubstituteEntitiesDefault(1);
/*XSL Transformation*/
	{
		xmlDocPtr			styleDoc	= xmlReadFile("copy-of-xsd-bug.xsl","",XML_PARSE_NOBLANKS);
		xsltStylesheetPtr	style		= xsltParseStylesheetDoc(styleDoc);
		xmlDocPtr	inputDoc = xmlReadFile("signature-minimal.xml","",XML_PARSE_NOBLANKS);
		const char *params[1];	params[0] = NULL;
		transformedDoc = xsltApplyStylesheet(style, inputDoc, params);
		xmlFreeDoc(inputDoc);
		xmlFreeDoc(styleDoc);
	}
/*XSD Compilation */
	{
		xmlSchemaParserCtxtPtr parserContext = xmlSchemaNewParserCtxt("DTE-minimal.xsd");
		xmlSchemaPtr schema = xmlSchemaParse(parserContext);
		int validationResult; 
		xmlSchemaFreeParserCtxt(parserContext);
		/* XSD Validation (In Memory) */
		{
			xmlSchemaValidCtxtPtr validationContext = xmlSchemaNewValidCtxt(schema);
			validationResult = xmlSchemaValidateDoc(validationContext, transformedDoc);
			fprintf(stderr,"In memory validation return Code = %d\n",validationResult);
			xmlSchemaFreeValidCtxt(validationContext);
		}
		/* XSD Validation (From disk) */
		xmlSaveFile("temporal.xml",transformedDoc);
		{
			xmlDocPtr diskDoc = xmlReadFile("temporal.xml","",XML_PARSE_NOBLANKS);
			xmlSchemaValidCtxtPtr validationContext = xmlSchemaNewValidCtxt(schema);
			validationResult = xmlSchemaValidateDoc(validationContext, diskDoc);
			fprintf(stderr,"From disk validation return Code = %d\n",validationResult);
			xmlSchemaFreeValidCtxt(validationContext);
		}
	}

/* libXSLT teardown */
	xsltCleanupGlobals();
}

